--- modules/core/classes/GalleryUtilities.class	2011-11-26 13:58:40.186252459 +0800
+++ modules.patch/core/classes/GalleryUtilities.class	2011-11-30 15:28:51.790757672 +0800
@@ -237,9 +237,27 @@
      */
     function getRequestVariables() {
 	$values = array();
+        // twu2 begin
+        // is running in nginx?
+        $is_nginx = strncmp($_SERVER['SERVER_SOFTWARE'], 'nginx', 5) == 0 ? true : false;
+        // twu2 end
 	foreach (func_get_args() as $argName) {
+/* original code
 	    $values[] = GalleryUtilities::_getRequestVariable(
 		GALLERY_FORM_VARIABLE_PREFIX . $argName);
+*/
+	    $s = GalleryUtilities::_getRequestVariable(
+		GALLERY_FORM_VARIABLE_PREFIX . $argName);
+            // twu2 begin
+            // maybe fix the issue with nginx, it change + to %2b
+            // then we got + here (in fact , it's ' ')
+            // only convert for g2_path and g2_fileName
+            if ($is_nginx  && ($argName == 'path' || $argName == 'fileName')) {
+                $x = str_replace('+', ' ', $s);
+                $s = $x;
+            }
+	    $values[] = $s;
+            // twu2 end
 	}
 
 	/* Sanitize the input */
